--$Name: Полёт в Петербург$
--$Version: 1.3.14$
--$Author:Александр Яковлев$

require "fmt"
if instead.tiny then
	function iface:tab()
		return '    '
	end
end

if not instead.tiny then
  require "theme"
end

fmt.dash = true
fmt.quotes = true

if std.SOURCES_DIRS == nil then
  std.SOURCES_DIRS = { 'parser', 'rooms' }
end
require 'parser/mp-ru'
mp.undo = 3
mp.auto_animate = false

function set_pic(f)
  if instead.tiny then
    return
  end
  --if theme.get('scr.gfx.bg') ~= f then
    theme.gfx.bg('bgr/'..f)
  --end
end

global {
  score = 0,
  maxscore = 3
}
game.dsc = ''
player.description = "Здесь нет зеркал. Но хотя бы ноги выглядят прекрасно.";
pl.plural = false
pl.pronouns = 'fem'
pl.strpronouns = 'она/её'

function givepoint()
  score = score + 1;
  pn 'Ваш счёт увеличился на 1 очко.';
end

dofile('custom_parser.lua')
dofile('rooms/end.lua')
dofile('rooms/objects.lua')
dofile('rooms/pantry.lua')


dlg {
  nam = 'main';
  decor = function(here)
    if not (here:visited()) then
      pn(fmt.b('Полёт в Петербург'));
      pn 'Фантастическая зарисовка^^';
      pn(fmt.b('Выберите свои местоимения^'));
      pn(fmt.em('Это - парсерная игра. Введите номер ответа и нажмите Enter. Игра управляется только с клавиатуры.^'));
      pn('Выбор позднее можно сменить командой «местоимения». Чтобы прочитать справку, наберите «помощь».');
    end
  end;
  continue = function()
    walk('pantry');
  end;
  title = function(here)
    if not (here:visited()) then
      return ''
    end
    return 'Выберите местоимения (сейчас -- "'.. pl.strpronouns ..'")'
  end;
  phr = {
    {
      nam = 'phr_she',
      cond = true,
      'она/ты',
      function()
        pl.plural = false;
        pl.pronouns = 'fem';
        pl.strpronouns = 'она/ты';
        std.player.word = 'ты/жр,2л';
        here().continue();
      end
    };
    {
      nam = 'phr_he',
      cond = true,
      'он/ты',
      function()
        pl.plural = false;
        pl.pronouns = 'masc';
        pl.strpronouns = 'он/ты';
        std.player.word = 'ты/мр,2л';
        here().continue();
      end
    };
    { 
      nam = 'phr_theysingle',
      cond = true,
      'оно/ты',
      function()
        pl.plural = false;
        pl.pronouns = 'other';
        pl.strpronouns = 'оно/ты';
        std.player.word = 'ты/cр,2л';
        here().continue();
      end
    };
    --[[
    { 
      nam = 'phr_theyplural',
      cond = true,
      'оно/вы',
      function()
        pl.plural = true;
        pl.pronouns = 'other';
        pl.strpronouns = 'оно/вы';
        std.player.word = 'вы/cр,2л';
        here().continue();
      end
    };
    ]]
    {
      nam = 'phr_plural',
      cond = true,
      'они/вы',
      function()
        pl.plural = true;
        pl.pronouns = 'other';
        pl.strpronouns = 'они/вы';
        std.player.word = 'вы/cр,мн,2л';
        here().continue();
      end
    }
  }
}
