-- Объекты, которые могут появиться на сцене, но изначально не присутствуют.

obj {
  -"рука/жр";
  nam = 'hand';
  canonical = 'рука';
  description = 'Пластиковая рука, как будто от манекена. Похоже, она левая.';
  before_Insert = function(self, what)
    if what^'robot' or what^'handsocket' then
      return false;
    end
    return 'Возможно, '..what:noun'им'..' с рукой выглядит интересной идеей, но руку некуда вставлять.';
  end;
  after_Insert = function(self, what)
    if what^'robot' or what^'handsocket' then
      pn [[Рука с щелчком входит в гнездо манипулятора. Робот выглядит чуточку человечнее.
      Можно попытаться его включить.]];
    end;
  end;
}: attr 'essential'

obj {
  -"тарелка/жр";
  canonical = 'тарелка';
  nam = 'plate';
  description = 'Пустая тарелка. Когда-то в ней были щи.';
}: dict {
  ['тарелка/рд'] = 'тарелку';
  ['тарелка/дт'] = 'тарелке';
  ['тарелка/вн'] = 'тарелку';
  ['тарелка/тв'] = 'тарелкой';
  ['тарелка/пр'] = 'тарелке';
}

obj {
  -"щи/ср,мн|тарелка,тарелка щей/жр";
  canonical = 'щи';
  nam = 'shi';
  description = 'Тарелка с остывшими щами. Выглядит не очень аппетитно.';
  before_Eat = function(s)
    s:remove();
    put('plate', here());
    return '{#You} жадно {#g/съедаешь,съедаете} щи без помощи столовых приборов. Не лучший обед в пути, но очень сытный.';
  end;
  before_Drink = function(s)
    s:remove();
    put('plate', here());
    return '{#You} жадно {#g/съедаешь,съедаете} щи без помощи столовых приборов. Не лучший обед в пути, но очень сытный.';
  end;
}: dict {
  ['щи/рд'] = 'щи';
  ['щи/дт'] = 'щам';
  ['щи/вн'] = 'щи';
  ['щи/тв'] = 'щами';
  ['щи/пр'] = 'щах';
}: attr 'edible'

obj {
  -"пластина/жр";
  canonical = 'пластина';
  nam = 'plastina';
  description = 'Гладкая стальная пластина с надписью «ПЯТНАДЦАТЫЙ». Вокруг неё обёрнута нитка.';
}: dict {
  ['пластина/рд'] = 'пластины';
  ['пластина/дт'] = 'пластине';
  ['пластина/вн'] = 'пластину';
  ['пластина/тв'] = 'пластиной';
  ['пластина/пр'] = 'пластине';
}

obj {
  -"платина/жр|металл/мр";
  nam = 'platina';
  description = 'Кусок белого металла. Когда-то он был очень ценным, но сейчас его проще синтезировать, чем искать в космосе.';
}: dict {
  ['платина/рд'] = 'платины';
  ['платина/дт'] = 'платине';
  ['платина/вн'] = 'платину';
  ['платина/тв'] = 'платиной';
  ['платина/пр'] = 'платине';
}

obj {
  -"патина/жр";
  scored = false;
  nam = 'patina';
  oncreate = function()
    p 'Статуя на верхней полке покрывается слоем патины.'
    here().dirty = true;
  end;
  description = 'Слой зеленоватой патины грязнит бронзовую статую.';
}: dict {
  ['патина/рд'] = 'патины';
  ['патина/дт'] = 'патине';
  ['патина/вн'] = 'патину';
  ['патина/тв'] = 'патиной';
  ['патина/пр'] = 'патине';
}

obj {
  -"пластика/жр";
  canonical = 'пластика';
  nam = 'plastika';
  description = 'Кусок белого пластилина. Он довольно бесполезен без духового шкафа.';
}: dict {
  ['пластика/рд'] = 'пластики';
  ['пластика/дт'] = 'пластике';
  ['пластика/вн'] = 'пластику';
  ['пластика/тв'] = 'пластикой';
  ['пластика/пр'] = 'пластике';
}

obj {
  -"булава/жр";
  canonical = 'булава';
  nam = 'bulava';
  oncreate = function()
    givepoint()
  end;
  description = 'Холодное оружие. Может пригодиться против… кого-нибудь.';
  before_Wave = 'Осторожнее с тяжёлым оружием. Здесь нечего ломать.';
}: dict {
  ['булава/рд'] = 'булавы';
  ['булава/дт'] = 'булаве';
  ['булава/вн'] = 'булаву';
  ['булава/тв'] = 'булавой';
  ['булава/пр'] = 'булаве';
}

obj {
  -"лама/жр";
  nam = 'lam';
  canonical = 'лама';
}: dict {
  ['лама/рд'] = 'ламы';
  ['лама/дт'] = 'ламе';
  ['лама/вн'] = 'ламу';
  ['лама/тв'] = 'ламой';
  ['лама/пр'] = 'ламе';
}:attr 'animate'

obj {
  -"лапа/жр";
  nam = 'paw';
  canonical = 'лапа';
  description = 'Искусственная лапка, свяленная из какой-то серой шерсти.';
  oncreate = function()
    pn 'Без источника света комната погружается во тьму. (Чтобы отменить последний ход, напишите ОТМЕНА.)'
  end;
}: dict {
  ['лапа/рд'] = 'лапы';
  ['лапа/дт'] = 'лапе';
  ['лапа/вн'] = 'лапу';
  ['лапа/тв'] = 'лапой';
  ['лапа/пр'] = 'лапе';
}

obj {
  -"полк/мр";
  canonical = 'полк';
  nam = 'polk';
}: dict {
  ['полк/рд'] = 'полка';
  ['полк/дт'] = 'полку';
  ['полк/вн'] = 'полк';
  ['полк/тв'] = 'полком';
  ['полк/пр'] = 'полке';
}:attr 'animate'

obj {
  -"Ника/жр";
  nam = 'nika';
}: dict {
  ['Ника/рд'] = 'Ники';
  ['Ника/дт'] = 'Нике';
  ['Ника/вн'] = 'Нику';
  ['Ника/тв'] = 'Никой';
  ['Ника/пр'] = 'Нике';
}:attr 'animate'

